<?php

// register plugin
$thisfile = basename(__FILE__, ".php");
register_plugin(
	$thisfile,
	'User config settings',
	'0.3',
	'Carlos Navarro',
	'http://www.cyberiada.org/cnb/',
	'Define user-specific gsconfig settings'
);

add_action('header','userconfig');

function userconfig() {
  global $USR;
  if ($USR) {
    global $EDHEIGHT;
    if ($EDHEIGHT) { // check for GS 3.3 editor global
      userconfig_set_var('EDTOOL','GSEDITORTOOL');
      userconfig_set_var('EDHEIGHT','GSEDITORHEIGHT');
      userconfig_set_var('EDLANG','GSEDITORLANG');
      userconfig_set_var('EDOPTIONS','GSEDITOROPTIONS');
    } else { // pre GS 3.3
      $settings = array('GSEDITORTOOL', 'GSEDITORHEIGHT', 'GSEDITORLANG', 'GSEDITOROPTIONS');
      foreach($settings as $setting) {
        if (!defined($setting)) {
          if (defined($setting.'_'.$USR))
            define($setting, constant($setting.'_'.$USR));
          else
            if (defined($setting.'_'))
              define($setting, constant($setting.'_'));
        }
      }
    }
    # allow other gsconfig settings
    if (defined('USERCONFIG')) {
      $settings = explode(',',str_replace(',,',',',str_replace(' ',',',USERCONFIG)));
      foreach ($settings as $setting) {
        if (!defined($setting)) {
          if (defined($setting.'_'.$USR))
            define($setting, constant($setting.'_'.$USR));
          else
            if (defined($setting.'_'))
              define($setting, constant($setting.'_'));
        }
      }
    }
  }
}

function userconfig_set_var($var, $const) {
  global $USR;
  if (defined($const.'_'.$USR))
    $tool = constant($const.'_'.$USR);
  elseif (defined($const.'_'))
    $tool = constant($const.'_');
  if (isset($tool)) {
    global $$var;
    $$var = $tool;  // GS 3.3+
    if (!defined($const))
      define($const, $tool); // plugins or GS 3.1-3.2
  }
}

// end
